//
//  FirstTabViewController.m
//  TabBar Navigation
//
//  Created by Holger Hinzberg on 11.04.11.
//  Copyright 2011 Cocoa-Coding. All rights reserved.
//

#import "FirstTabViewController.h"


@implementation FirstTabViewController
@synthesize redSlider;
@synthesize greenSlider;
@synthesize blueSlider;
@synthesize hexValueLabel;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [redSlider release];
    [greenSlider release];
    [blueSlider release];
    [hexValueLabel release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView
{
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    [self setBackColor];
}


- (void)viewDidUnload
{
    [self setRedSlider:nil];
    [self setGreenSlider:nil];
    [self setBlueSlider:nil];
    [self setHexValueLabel:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (IBAction)redSliderMove:(id)sender
{
    [self setBackColor];
}

- (IBAction)greenSliderMove:(id)sender 
{
    [self setBackColor];
}

- (IBAction)blueSliderMove:(id)sender 
{
    [self setBackColor];
}

// Setzen der Hintergrundfarbe
-(void)setBackColor;
{
    // Die Werte von den Schiebereglern holen.
    float greenValue = greenSlider.value;
    float redValue = redSlider.value;
    float blueValue = blueSlider.value;
    
    // Zeichenkette erzeugen.
    NSString *hexString =
    [self generateHexStringWithRed:redValue
                             green:greenValue
                              blue:blueValue];
    
    // NSLog(@"%@",hexString);
    hexValueLabel.text = hexString;
    
    // Die Werte umrechnen.
    greenValue = greenValue / 255.0;
    redValue = redValue / 255.0;
    blueValue = blueValue / 255.0;
    
    // Ein UIColor-Objekt konfigurieren
    UIColor *bgColor = [UIColor colorWithRed:redValue
                                       green:greenValue
                                        blue:blueValue
                                       alpha:1.0f];
    
    // Die Farbe des View setzten.
    [self.view setBackgroundColor:bgColor];
}

-(NSString *)generateHexStringWithRed:(double)redValue
                                green:(double)greenValue
                                 blue:(double)blueValue
{
    // Farbanteil in einen hexadezimalen 
    // Wert umwandeln.
    NSString *greenString 
    = [NSString stringWithFormat:@"%02x",
       (int) greenValue];
    
    NSString *redString 
    = [NSString stringWithFormat:@"%02x",
       (int) redValue];
    
    NSString *blueString 
    = [NSString stringWithFormat:@"%02x",
       (int) blueValue];
    
    // Einen NSMutableString mit #.
    NSMutableString *hexString 
    = [NSMutableString stringWithString:@"#"];
    
    // Einzelne Farbanteile zusammenbauen
    [hexString appendString:redString];
    [hexString appendString:greenString];
    [hexString appendString:blueString];
    
    // In Großbuchstaben umwandeln.
    return [hexString uppercaseString];
}

@end
