//
//  ThirdTabViewController.m
//  TabBar Navigation
//
//  Created by Holger Hinzberg on 11.04.11.
//  Copyright 2011 Cocoa-Coding. All rights reserved.
//

#import "ThirdTabViewController.h"


@implementation ThirdTabViewController
@synthesize animationView;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [animationView release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView
{
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // Die Bounds:
	// Position und Abmessungen für den View.
    CGRect viewRect = CGRectMake(20, 20, 70, 70);
    
    [animationView setBounds:viewRect];
    
	// Die Hintergrundfarbe für den Start
    [animationView setBackgroundColor:
     [UIColor redColor]];
}


- (void)viewDidUnload
{
    [self setAnimationView:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (IBAction)colorControlValueChanged:(id)sender
{
    // Den sender in ein Steuerelement umwandeln.
    UISegmentedControl *colorControl = sender;
    
    // Der Index des gewählten Segments
    int index = colorControl.selectedSegmentIndex;
    
    UIColor *selectedColor = [UIColor redColor];
    
    // Ermitteln der passenden Farbe
    switch (index)
    {
        case 0:
            selectedColor =
            [UIColor redColor];
            break;
            
        case 1:
            selectedColor =
            [UIColor greenColor];
            break;
            
        case 2:
            selectedColor =
            [UIColor blueColor];
            break;            
            
        default:
            break;
    }
    
    // Dem animationView eine neue Hintergrund
    // Farbe zuweisen.    
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.5];
    
    [animationView setBackgroundColor:selectedColor];
    
    [UIView commitAnimations];
}

- (IBAction)animationControlValueChanged:(id)sender 
{
    // Den sender in ein Steuerelement umwandeln.
    UISegmentedControl *colorControl = sender;
    
    // Der Index
    // 0 = oben links
    // 1 = unten links
    // 2 = oben rechts
    // 3 = unten rechts
    int index = colorControl.selectedSegmentIndex;
    
    CGPoint centerPosition;
    
    switch (index)
    {
        case 0:
            centerPosition = CGPointMake(55, 55);
            break;
        case 1:
            centerPosition = CGPointMake(55, 250);
            break;
        case 2:
            centerPosition = CGPointMake(265, 55);
            break;
        case 3:
            centerPosition = CGPointMake(265, 250);
            break;
        default:
            break;
    }
    
    // Animation vorbereiten
    [UIView beginAnimations:nil context:NULL];
    // Die Dauer der Animation, in Sekunden
    [UIView setAnimationDuration:0.5];
    // Die neue Position setzten
    animationView.center = centerPosition;
    // Animation starten
    [UIView commitAnimations];
}
@end
